import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.GridLayout;
import java.awt.event.*;
import javax.swing.*;

public class Cliente extends JFrame implements ActionListener {

        private JLabel Tit1 = new JLabel ("Server",SwingConstants.CENTER);
        private JLabel Tit2 = new JLabel ("Cliente",SwingConstants.CENTER);
        private JTextField MsgSvr = new JTextField("Attesa di connessione",20);
        private JTextField MsgClient = new JTextField("",20);
        private JButton pulsante = new JButton("Invia");
        private JLabel Vuoto = new JLabel();
        private static BufferedReader in;
        private static PrintWriter out; 
        private static Socket socket;

        public Cliente(String indirizzo ,String porta) {

                super ("Cliente1");
                
                MsgSvr.setEditable(false);


                JPanel pannello = new JPanel();
                

                pannello.setLayout(new GridLayout (3,2,5,8));
                pannello.add(Tit1);
                pannello.add(MsgSvr);
                pannello.add(Tit2);
                pannello.add(MsgClient);
                pannello.add(Vuoto);
                pannello.add(pulsante);
                setContentPane(pannello); 

                try {

                        InetAddress addr =
                        InetAddress.getByName(indirizzo);
                        socket =
                        new Socket(addr, Integer.parseInt(porta));
                        try {
                                in =
                                new BufferedReader(new InputStreamReader(
                                socket.getInputStream()));
                                out =
                                new PrintWriter(
                                new BufferedWriter(new OutputStreamWriter(
                                socket.getOutputStream())),true);
                                MsgSvr.setText("Connessione avvenuta");
                                pulsante.addActionListener(this);
                                repaint();
                                } catch(IOException e) {
                                        MsgSvr.setText("closing...");
                                        socket.close();}
                        } catch(IOException e) {}
        }

        public static void main(String[] args) {
                if (args.length != 2) {
                        System.out.println("Uso: Cliente indirizzo numeroporta");
                        System.exit(1);
                }
                JFrame frame = new Cliente(args[0],args[1]);
                WindowListener l = new WindowAdapter() {
                        public void windowClosing(WindowEvent e) {
                            try{    
                                
                                out.println("END");
                                out.close();
                                socket.close();
                                System.exit(0);}  catch(IOException er) {}
                        }
                };

                frame.addWindowListener(l);

                frame.pack();
                frame.setVisible(true);


        }

        public void actionPerformed(ActionEvent evt) {

                String messaggio;

                Object source = evt.getSource();

                if (source == pulsante ) {
                   try {messaggio = MsgClient.getText();
                        out.println(messaggio);
                        String str = in.readLine();
                        MsgSvr.setText(""+str);
                        MsgClient.setText("");} catch(IOException e) {};


                }
              
                repaint();
        }

}
